local AddOn, NS = ...
local strlen, strgmatch, strsub, strgsub  = string.len, string.gmatch, string.sub, string.gsub
local floor = math.floor

function DUF_TextBox_OnEvent(self, event, ...)
	if (not DUF_INITIALIZED) then return end
	local arg1, arg2, arg3, arg4 = ...
	if (arg1 ~= self:GetParent().unit) then return end
	if (event == "UNIT_COMBAT") then
		self.damagetext = ""
		self.healtext = ""
		if( arg2 == "IMMUNE" ) then
			self.damagetext= "|cFFFFFF00"..CombatFeedbackText["IMMUNE"]
		elseif ( arg2 == "WOUND" ) then
			if ( arg3 == "ABSORB" )then
				self.damagetext= "|cFFFFFFFF"..ABSORB
			elseif ( arg4 ~= 0 ) then
				if ( arg3 == "CRITICAL" ) then
					self.damagetext= "|cFFFF00FF"..DUF_TEXT.Crit.."|cFFFF0000".."-"..arg4
				end
				self.damagetext= "|cFFFF0000".."-"..arg4
			else
				self.damagetext= "|cFFFFFF00"..CombatFeedbackText["MISS"]
			end
		elseif ( arg2 == "BLOCK" ) then
			self.damagetext= "|cFFFFFF00"..BLOCK
		elseif ( arg2 == "HEAL" ) then
			self.healtext= "|cFF00FF00".."+"..arg4
			if ( arg3 == "CRITICAL" ) then
				self.healtext= "|cFFFF00FF"..DUF_TEXT.Crit.."|cFF00FF00".."+"..arg4
			end
		else
			self.damagetext= CombatFeedbackText[arg2]
		end
		self.combattexttimer = 1.5
	elseif (event == NS.UNIT_HEALTH_EVENT) then
		local health = UnitHealth(self:GetParent().unit)
		if (not self.lasthealth) then
			self.lasthealth = health
		end
		local gain = health - self.lasthealth
		if (health == UnitHealthMax(self:GetParent().unit) or (not DL_REGEN)) then
			self.healthregen = 0
			self.healthregentick = 0
			self.healthtable = nil
		elseif (gain > 0) then
			self.healthregentick = gain
			
			if (not self.healthtable) then
				self.healthtable = {}
				local time = GetTime()
				for i=1,4 do
					self.healthtable[i] = { v=0, t=time }
				end
				self.healthtable[5] = { v=gain, t=time }
			else
				for i=1,4 do
					self.healthtable[i].v = self.healthtable[i + 1].v
					self.healthtable[i].t = self.healthtable[i + 1].t
				end
				self.healthtable[5].v = gain
				self.healthtable[5].t = GetTime()
			end
			local totalhealth = 0
			for i=1,5 do
				totalhealth = totalhealth + self.healthtable[5].v
			end
			local seconds = (GetTime() - self.healthtable[1].t)
			if (seconds == 0) then
				self.healthregen = 0
			else
				self.healthregen = floor(totalhealth / seconds * 10) / 10
			end
		end
		self.lasthealth = health
	elseif event == "UNIT_POWER_FREQUENT" then --and (arg2 == "MANA" or arg2 == "RAGE" or arg2 == "ENERGY" or arg2 == "FOCUS"  or arg2 == "RUNIC_POWER"  or arg2 == "HOLY_POWER") then
		local mana = UnitPower(arg1)
		if (not mana) then mana = 0 end
		if (not self.lastmana) then
			self.lastmana = mana
		end
		local gain = mana - self.lastmana
		if (mana == UnitPowerMax(self:GetParent().unit)) then
			self.manaregen = 0
			self.manaregentick = 0
			self.manatable = nil
		elseif (gain > 0) then
			self.manaregentick = gain
			if (not self.manatable) then
				self.manatable = {}
				local time = GetTime()
				for i=1,4 do
					self.manatable[i] = { v=0, t=time }
				end
				self.manatable[5] = { v=gain, t=time }
			else
				for i=1,4 do
					self.manatable[i].v = self.manatable[i + 1].v
					self.manatable[i].t = self.manatable[i + 1].t
				end
				self.manatable[5].v = gain
				self.manatable[5].t = GetTime()
			end
			local totalmana = 0
			for i=1,5 do
				totalmana = totalmana + self.manatable[5].v
			end
			local seconds = (GetTime() - self.manatable[1].t)
			if (seconds == 0) then
				self.manaregen = 0
			else
				self.manaregen = floor(totalmana / seconds * 10) / 10
			end
		end
		self.lastmana = mana
	elseif (event == DUF_UNIT_CHANGED_EVENTS[self:GetParent().unit]) then
		DUF_Element_OnShow(self)
	end
	NS:DUF_TextBox_Update(self)
end

function DUF_TextBox_OnUpdate(self, elapsed)
	if (not DUF_INITIALIZED or not self:IsVisible() or self:GetAlpha() == 0) then return end
	if (self.combattexttimer) then
		self.combattexttimer = self.combattexttimer - elapsed
		if (self.combattexttimer < 0) then
			self.combattexttimer = nil
			self.damagetext = ""
			self.healtext = ""
			NS:DUF_TextBox_Update(self)
		end
	end
	if not self.update then return end
	self.timer = self.updatespeed
	self.update = nil
	local unit = self:GetParent().unit
	local updateTextBox
	if (self.pvpcd and UnitIsPVP(unit)) then -- Fizzlemizz: PVP Countdown Timer
		updateTextBox = true
	end
	if (self.checkname) then
		local name = DL_UnitName(unit.."target")
		if (UnitIsUnit(unit.."target", "player")) then
			name = DUF_TEXT.You
		elseif (UnitIsUnit(unit.."target", "target")) then
			name = DUF_TEXT.YourTarget
		end
		if (name ~= self.targetname) then
			self.targetname = name
			updateTextBox = true
		end
	end
	if (self.checkhealth) then
		local health = NS:DUF_Get_Health(unit.."target")
		if (health ~= self.targethealth) then
			self.targethealth = health
			updateTextBox = true
		end
	end
	if (self.checkbosshealth) then
		local health = NS:DUF_Get_Health(unit)
		local frame = _G[DUF_FRAME_DATA[unit].frame]
		if (health ~= self.bosshealth) then
			self.bosshealth = health
			DUF_TextBox_OnEvent(self, NS.UNIT_HEALTH_EVENT, unit)
		end
	end
	if (self.checkhealthmax) then
		local health = NS:DUF_Get_MaxHealth(unit.."target")
		if (health ~= self.targethealthmax) then
			self.targethealthmax = health
			updateTextBox = true
		end
	end
	if (self.checkmana) then
		local mana = UnitPower(unit.."target")
		if (self.targetmana ~= mana) then
			self.targetmana = mana
			updateTextBox=true
		end
	end
	if (self.checkmanamax) then
		local mana = UnitPowerMax(unit.."target")
		if (self.targetmanamax ~= mana) then
			self.targetmanamax = mana
			updateTextBox=true
		end
	end
	if (self.checklevel) then
		local level = UnitLevel(unit.."target")
		if (self.targetlevel ~= level) then
			self.targetlevel = level
			updateTextBox = true
		end
	end
	if (self.checktype) then
		local ctype
		if (UnitIsPlayer(unit.."target")) then
			ctype = UnitClass(unit.."target")
		else
			ctype = UnitCreatureType(unit.."target")
		end
		if (ctype ~= self.targettype) then
			self.targettype = ctype
			updateTextBox = true
		end
	end
	if (self.checkreaction) then
		local reaction = UnitReaction("player", unit)
		if (reaction ~= self.ttreaction) then
			self.ttreaction = reaction
			updateTextBox = true
		end
	end
	if (self.checkoffline) then
		local connected = UnitIsConnected(unit)
		if (connected ~= self.connected) then
			self.connected = connected
			updateTextBox = true
		end
	end
	if (self.checkcombat) then
		local ic = UnitAffectingCombat(unit)
		if (ic ~= self.incombat) then
			self.incombat = ic
			updateTextBox = true
		end
	end
	if (self.checkpetxp) then
		local min,max = NS.GetPetExperience()
		if (min ~= self.minpetxp or max ~= self.maxpetxp) then
			self.minpetxp = min
			self.maxpetxp = max
			updateTextBox = true
		end
	end
	if (self.checkvisibility) then
		local visibility = UnitIsVisible(unit)
		if (self.visibility ~= visibility) then
			self.visibility = visibility
			updateTextBox = true
		end
	end
	if (self.checkcolor) then
		updateTextBox = true
	end
	if (updateTextBox) then
		NS:DUF_TextBox_Update(self)
	end
end

function NS:DUF_TextBox_Update(Textbox)
	if (not Textbox) then return end
	local unit = Textbox:GetParent().unit
	local id = Textbox:GetID()
--[[
	local text = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].TextBox[id].text
	local maxchar = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].TextBox[id].maxcharacters
	local hideifnotext = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].TextBox[id].hideifnotext
	local hideiftextis = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].TextBox[id].hideiftextis or ""
	local vert = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].TextBox[id].verttext
]]--
	local Settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].TextBox[id]
	local text = Settings.text
	local maxchar = Settings.maxcharacters
	local hideifnotext = Settings.hideifnotext
	local hideiftextis = Settings.hideiftextis or ""
	local vert = Settings.verttext
	local enableMouse = not Settings.disablemouse
	if ((not text) or text == "") then return end
	if (Textbox.variables) then
		for var in pairs(Textbox.variables) do
			text = NS.DUF_VARIABLE_FUNCTIONS[var].func(text, unit, Textbox)
		end
	end
	if (not text) then text = "" end
	if (maxchar) then
		local numchar = strlen(text)
		local count = 0
		for i in strgmatch(text, "|c") do
			count = count + 1
		end
		numchar = numchar - count * 10
		if (numchar > maxchar) then
			text = strsub(text, 1, maxchar + count * 10)
		end
	end
	if (vert) then
		text = strgsub(text, "(.)", function(x) return x.."\n" end)
	end
	if hideifnotext then
		if text == "" or text == hideiftextis then
--			text = ""
			Textbox:SetAlpha(0.01)
--			Textbox:EnableMouse(false)
		else
			Textbox:SetAlpha(1)
--			Textbox:EnableMouse(enableMouse)
		end
	end
	Textbox.TextString:SetText(text)
end
